clear
err_bb=[0.17699,0.094541,0.048683,0.024733]; %Error with complete bounceback bc
err_eqbc=[0.082173,0.040687,0.020187,0.010048]; %Error with equilibrium bc
err_jlfd=[0.014109,0.0035617,0.00089266,0.00022326]; %Error with Jonas Latt Finite Difference bc
% err_pressure_vel_O2=[0.009816,0.0024545,0.00064201,0.00017634]; %Pressure driven
err_pressure_vel_O1=[0.0081763,0.0020193,0.00051693,0.0001308]; %Pressure driven
err_pressure_pressure=[0.29945,0.12978,0.061662,0.030335];      %Pressure driven

% Half Poiseuille flow
NY_half=[10,20,40,80];
err_vel_half_poiseuille=[0.007618,0.0019269,0.000492695,0.000125025];                       
err_pressure_half_poise=[0.23189,0.094995,0.0436225,0.0209325];

NY=[10,20,40,80];
const1=5; %const1=c, comment!
x=10:0.01:80;
y=const1*x.^(-1);
yy=const1*x.^(-2);
 
figure(1)
loglog(NY,err_bb,'k*',NY,err_eqbc,'kd')
hold on
plot(x,y,'k-')

axis([5*10^0 10^2 5*10^(-3) 10^0])
grid on
title('Error of gravity driven Poiseuille flow with different BCs')
legend('Complete Bounceback','Equilibrium BC','Slope = -1')
xlabel('N')
ylabel('Error')

figure(2)
loglog(NY,err_jlfd,'kx',NY,err_pressure_vel_O1,'k*',NY,err_vel_half_poiseuille,'r.')
hold on
plot(x,yy,'k-')
axis([5*10^0 10^2 2*10^(-5) 10^(-1)])
grid on
title('Velocity Error with FD boundary conditions of Ltt')
legend('Gravity driven','Pressuredriven l_x=1','Pressuredriven l_x=2','Slope = -2')
xlabel('N')
ylabel('Error')
% 
figure(3)
loglog(NY,err_pressure_pressure,'k*',NY,err_pressure_half_poise,'kd')
hold on
plot(x,y,'k-')
axis([5*10^0 10^2 5*10^(-3) 10^(0)])
grid on
title('Pressure Error with FD boundary conditions of Ltt')
legend('Pressuredriven l_x=1','Pressuredriven l_x=2','Slope = -1')
xlabel('N')
ylabel('Error')
% 
% figure(4)
% plot(NY,err_pressure_vel_O1,'k*',NY,err_vel_half_poiseuille,'r.')
% hold on
% plot(x,yy,'k-')
% axis([5*10^0 10^2 2*10^(-5) 0.01])
% grid on
% title('Velocity Error with FD boundary conditions of Ltt')
% legend('Pressuredriven l_x=1','Pressuredriven l_x=2','Slope = -2')
% xlabel('N')
% ylabel('Error')


% figure(5)
% loglog(NY_half,err_pressure_half_poise,'k*')
% hold on
% plot(x,y*0.7,'k-')
% axis([5*10^0 10^2 10^(-2) 10^(0)])
% grid on
% title('Pressure Error Half Width Channel')
% legend('JLFD','Slope -1')
% xlabel('N')
% ylabel('Error')






