clear
NX=41; 
NY=41; 
% use odd number of nodes
x0=(NX+1)/2; y0=(NY+1)/2; r0=(NX-1)/4;
R0=2*r0;
beta_r=0.5;
% NEW FORMULATION!!

sections=NY-1;
h=1/sections; %Grid spacing
u_L=h; %Lattice speed

% u0*r0 is the same....

% --------opprinnelig ...----------
%Prv Re=u_L*N/nu_L
Re=10;
nu=1/Re; %Physical
tau=3*nu+0.5;
omega=1/tau;
% ----------------------------------
% u_L=1/320;
% Re=10;
% nu_L=u_L*NY/Re; %Numerical
% tau_L=3*nu_L+0.5;
% omega=1/tau_L;
% omega
% omega=10/6;
% omega=1.96078;
% tau=1/omega;
% nu_L=(1/3)*(tau-0.5);
% Re=10;
% frekvens=nu*Re/(R0-r0)/r0;
% frekvens=nu_L*Re/(R0-r0)/r0; %or:1/(R0-r0)/r0 ??
frekvens=1/(R0-r0)/r0;
FREKVENS=0; %ALWAYS!
u0=frekvens*r0;
U0=FREKVENS*R0;
rho_R0=1; %Density at outer cylinder wall

% Global variables
global t;global cx;global cy;global q;
[t,cx,cy,q]=d2q9();

[x,y]=meshgrid(1:NX,1:NY);

tic;

% % ###### Taylor-Vortex #########

% [ub,polynomials,fluid ...
%     u0_r,r ...
%     boundary,BOUNDARY,p,obst,OBST,bound_fluid,fluid_opp,fluid_opp_bound_opp,lms_app,lms] = lattemain(NX,NY,x0,y0,R0,r0,x,y);
% 'ub' includes u0!

% % ###### Couette ##############
[ub,polynomials,UB,POLYNOMIALS,fluid ...
    u0_r,U0_R,r,R ...
    boundary,BOUNDARY,p,P,obst,OBST,bound_fluid,fluid_opp,fluid_opp_bound_opp,lms_app,LMS_APP,lms,LMS] = lattemain(NX,NY,x0,y0,R0,r0,FREKVENS,frekvens,x,y);
toc
% break
% AR=NX/NY;
% sections_x=NX-1;
% sections_y=NY-1;
% h=1/sections_x; %Grid spacing x
% u_L=h; %Lattice speed
% Re=10; %Reynolds number
% % nu_L=u_L*sections/Re; %Lattice viscosity
% % nu_L=1/Re; %Lattice viscosity
% nu_L=(R0-r0)*u0/Re;
% tau=3*nu_L + 0.5; %Relaxation time scale
% omega=1/tau; %Relaxation frequency

wetnodes=1-OBST-obst;
[wet_y,wet_x]=find(wetnodes);
wet=[wet_x,wet_y];


% Compute ANALYTICAL solution here
[ux_ana,uy_ana,dudx_ana,dudy_ana,dvdx_ana,dvdy_ana,rho_ana,p_ana,ux_ana2,uy_ana2] = couette_ana(NX,NY,x0,y0,R0,beta_r,u0,obst,OBST,u_L);
% break                                                                              

[Qxx,Qxy,Qyy] =Q_comp();

% Define initial values
ux=zeros(NY,NX);uy=zeros(NY,NX);rho=ones(NY,NX);
f=f_comp(ux,uy,NY,NX,rho);

maxitr=10000;

for n=1:maxitr;
    
    if mod(n,2000)==0
        disp(num2str(n))
    end

rho=density_comp(f);
[ux,uy]=velocity_comp(f,rho);

% ux=zeros(NY,NX);uy=zeros(NY,NX);rho=ones(NY,NX);

% Update velocity on boundary nodes, u(P)
[ux,uy] = u_update(ux,uy,ux_ana,uy_ana,ub,polynomials);
[ux,uy] = u_update(ux,uy,ux_ana,uy_ana,UB,POLYNOMIALS);
% break
[dudx,dudy,dvdx,dvdy]             = rate_of_strain_fluid(NX,NY,ux,uy,fluid);
[Sxx,Sxy,Syy,dudx,dudy,dvdx,dvdy] = rate_of_strain_bound(dudx,dudy,dvdx,dvdy,ux,uy,u0_r,r,boundary,p); %inner
[Sxx,Sxy,Syy,dudx,dudy,dvdx,dvdy] = rate_of_strain_bound(dudx,dudy,dvdx,dvdy,ux,uy,U0_R,R,BOUNDARY,P); %outer
% [Sxx,Sxy,Syy]                     = ros_ana(Sxx,Sxy,Syy,dudx_ana,dudy_ana,dvdx_ana,dvdy_ana,ub); %inner boundary nodes
% [Sxx,Sxy,Syy]                     = ros_ana(Sxx,Sxy,Syy,dudx_ana,dudy_ana,dvdx_ana,dvdy_ana,UB); %outer boundary nodes
% break
% Sxx=zeros(NY,NX);Sxy=zeros(NY,NX);Syy=zeros(NY,NX); %First order
QS = QS_comp(Qxx,Qxy,Qyy,Sxx,Sxy,Syy); 

geq  = geq_comp(NY,NX,ux,uy);
gneq = gneq_comp(omega,QS);
g    = g_comp(geq,gneq);


% Update density on boundary nodes
rho = rho_update_nonlocal(POLYNOMIALS,UB,rho,rho_R0,rho_ana);

rho = rho_update_local_fopp_bopp(rho,f,g,fluid_opp_bound_opp,wetnodes,rho_ana,rho_R0);
% rho = rho_update_local_fopp(rho,f,g,fluid_opp,wetnodes,rho_ana,rho_R0);
 

% pressure = 1/3*(rho-1)/u_L^2; %Physical
% break

[feq,fneq]=f_rho_g(rho,geq,gneq);
f=f_reconstruct(feq,fneq,f,boundary,BOUNDARY); 
fout=collision(f,feq,omega);
f=streaming(fout,f);

% % RESULTS
[error_vel_x,error_vel_y,error_pressure,pressure] = results_couette(NX,NY,ux,uy,ux_ana,uy_ana,x0,y0,r0,R0,u_L,p_ana,rho,wet);

end




% RESULTS
% [error_vel_x,error_vel_y] = results_couette(ux,uy,ux_ana,uy_ana,x0,y0,r0,R0,u_L);
disp(['With ',num2str(NY), ' nodes:'])
format long
disp(['Error in x-velocity is: ',num2str(error_vel_x)])
disp(['Error in y-velocity is: ',num2str(error_vel_y)])
disp(['Error in pressure   is: ',num2str(error_pressure)])


