function [ux_ana,uy_ana,dudx_ana,dudy_ana,dvdx_ana,dvdy_ana,rho_ana,p_ana,ux_ana2,uy_ana2] = couette_ana(NX,NY,x0,y0,R0,beta_r,u0,obst,OBST,u_L)
% NB! R0 in argument list
ux_ana=zeros(NY,NX);
uy_ana=zeros(NY,NX);
p_ana=zeros(NY,NX);

ux_ana2=zeros(NY,NX);
uy_ana2=zeros(NY,NX);

dudx_ana = zeros(NY,NX);
dudy_ana = zeros(NY,NX);
dvdx_ana = zeros(NY,NX);
dvdy_ana = zeros(NY,NX);

wetnodes=1-OBST-obst;
[wet_y,wet_x]=find(wetnodes);
wet=[wet_x,wet_y];
wet_x=wet(:,1);
wet_y=wet(:,2);
betaconst=(beta_r/(1-beta_r^2))^2; %p
C      =  u0*beta_r/(1-beta_r^2);
% ur_ana=zeros(NY,NX);

for i=1:length(wet)
a=wet_x(i);
b=wet_y(i);

x=a-x0;
y=b-y0;
r=sqrt(x^2 + y^2);
A=abs(y/x);
t=atan(A);
% A=      y/x;
% B= abs(A);
% theta =  atan(A);
% thetaB=  atan(B);

ur_ana=  C*(R0/r - r/R0); %Dim less now??
% r=sqrt(x^2 + y^2)/

ux_ana(b,a)=-ur_ana*sin(t)*sign(y);
uy_ana(b,a)= ur_ana*cos(t)*sign(x);

ux_ana2(b,a)= -ur_ana*y/r;
uy_ana2(b,a)=  ur_ana*x/r;

dudr=C*(R0/r^2 + 1/R0)*sin(t)*sign(y); %dux/dr
dvdr=-C*(R0/r^2 + 1/R0)*cos(t)*sign(x); %duy/dr
drdx=x/r;
drdy=y/r;
dudt=-ur_ana*cos(t)*sign(y); %dux/d(theta)
dvdt=-ur_ana*sin(t)*sign(x); %duy/d(theta)

dtdA=1/(1+A^2); %d(theta)/dA
dAdx=-y/x^2;
dAdy=1/x;
dtdx=dtdA*dAdx;
dtdy=dtdA*dAdy;

dtdx=-y/r^2; %d(theta)/dx
dtdy= x/r^2; %d(theta)/dy

dudx_ana(b,a)=dudr*drdx + dudt*dtdx;
dudy_ana(b,a)=dudr*drdy + dudt*dtdy;
dvdx_ana(b,a)=dvdr*drdx + dvdt*dtdx;
dvdy_ana(b,a)=dvdr*drdy + dvdt*dtdy;

% dudr  =  C*(R0/r^2 + 1/R0)*sin(theta);
% dvdr  = -C*(R0/r^2 + 1/R0)*cos(theta);
% drdx  =  x/r; 
% drdy  =  y/r;
% dudt  = -ur_ana*cos(theta);
% dvdt  = -ur_ana*sin(theta);
% dAdx  = -y/x^2;
% dAdy  =  1/x;
% dtdA  =  1/(1+A^2);
% 
% dtdx  =  dtdA*dAdx;
% dtdy  =  dtdA*dAdy;
% 
% if x==0
%     dtdx=0;
%     dtdy=0;
% end
% 
% % ux_ana(b,a)=-ur_ana*sin(theta);
% % uy_ana(b,a)= ur_ana*cos(theta);
% 
% ux_ana(b,a)=-ur_ana*sin(thetaB)*sign(y);
% uy_ana(b,a)= ur_ana*cos(thetaB)*sign(x);
% 
% dudx_ana(b,a) = dudr*drdx + dudt*dtdx;
% dudy_ana(b,a) = dudr*drdy + dudt*dtdy;
% dvdx_ana(b,a) = dvdr*drdx + dvdt*dtdx;
% dvdy_ana(b,a) = dvdr*drdy + dvdt*dtdy;
% 

p_ana(b,a)=betaconst*(r^2/R0^2 - R0^2/r^2 -4*log(r/R0)); %Physical (non-dim)

end

rho_ana=3*p_ana*u_L^2 + 1;

% beta_r=0.5;
% betaconst=(beta_r/(1-beta_r^2))^2;
% r2=1;
% r=linspace(0.5,1,20);
% pstar=betaconst*((r.^2)./r2^2 - (r2^2)./r.^2 -4*log(r./r2));
% plot(r,pstar)
% xlabel('r')
% ylabel('p^{*}')





