function [p,r] = p_find(bound_fluid,cylinder_x,cylinder_y,obst)
% P_FIND finds the points p corresponding to each boundary node that is needed
% in the computation of the rate of strain tensor S. The points are located
% the minimum distance between P and the neighboring nodes P + c_i,
% where i=1,2,3,4, and the cylinder. That is:
% P + c_1 == P_E, 
% P + c_2 == P_N,
% P + c_3 == P_W,
% P + c_4 == P_S, and 

% p = [P_E, P_N, P_W, P_S] for all P

global cx
global cy

[bs_y,bs_x]=find(obst);
bs=[bs_x,bs_y];

% p=zeros(length(boundary_fluid,8));
for i=1:length(bound_fluid)
       
    for j=1:4
        c=[cx(j),cy(j)];
          p(i,j*2-1:j*2) = bound_fluid(i,1:2) + c;
%           r here!

pc_x=[bound_fluid(i,1),p(i,j*2-1)];
pc_y=[bound_fluid(i,2),p(i,j*2)];

[rx,ry]=curveintersect(pc_x,pc_y,cylinder_x,cylinder_y);


for k=1:length(bs)
if isempty(rx) && pc_x(2)==bs(k,1) ...
       && pc_y(2)==bs(k,2);
   rx=bs(k,1);
   ry=bs(k,2);
end
end


% If no H0, set H0 identically equal to zero. NB! Only if 'inner' cylinder
if isempty(ry) ...
%         || isempty(rx)
    rx=0;
    ry=0;
    
end


% Only one intersection per cardinal point

r(i,j*2-1:j*2)=[rx(1),ry(1)];        

    end
end
     
        
        
%         if bound_f_opp(m,3,i) == 0
%             linkmatrix(3:10)=0;
%         end  