function [error_vel_x,error_vel_y,error_pressure,pressure] = results_couette(NX,NY,ux,uy,ux_ana,uy_ana,x0,y0,r0,R0,u_L,p_ana,rho,wet)
% 'results_couette' computes the error in velocity and pressure for the
% Taylor-Couette flow.
                                                        
a=ceil(x0+r0+1):floor(x0+R0-1);
b=ceil(y0+r0+1):floor(y0+R0-1);

% uprofile=ux(b,x0)/u_L;
% vprofile=uy(y0,a)/u_L;

error_vel_x=(1/length(b))*sum(sqrt((ux(b,x0)/u_L-ux_ana(b,x0)/u_L).^2+(uy(b,x0)/u_L).^2));
error_vel_y=(1/length(a))*sum(sqrt((uy(y0,a)/u_L-uy_ana(y0,a)/u_L).^2+(ux(y0,a)/u_L).^2));

% error_vel_O1=      (1/NY)*sum(sqrt((uprofile-ux_ana(:,ceil(NX/2))/u_L).^2+vprofile.^2));

% error_vel_y=0; %quit '_y'
% for i=1:length(wet)
%     e=wet(i,1);
%     f=wet(i,2);
%     
%     error_vel_y = error_vel_y + ...
%         (ux(f,e)/u_L - ux_ana(f,e)/u_L)*(ux(f,e)/u_L - ux_ana(f,e)/u_L) + ...
%         (uy(f,e)/u_L - uy_ana(f,e)/u_L)*(uy(f,e)/u_L - uy_ana(f,e)/u_L);
% end
% error_vel_y=sqrt(error_vel_y/length(wet));

pressure = 1/3*(rho-1);

error_pressure=0;
for i=1:NY 
    for j=1:NX
    error_pressure= error_pressure + ...
    ((pressure(i,j)/u_L^2 - p_ana(i,j))*(pressure(i,j)/u_L^2 - p_ana(i,j))); 
    end
end

% error_pressure=sqrt(error_pressure/length(wet));
error_pressure=sqrt(error_pressure/NX/NY);
% error_pressure=1/3/u_L^2*sqrt(error_pressure/NX/NY);