function rho = rho_update_nonlocal(POLYNOMIALS,UB,rho,rho_R0,rho_ana)
% rho_update updates the macroscopic density at the boundary nodes by means
% of non-local Lagrange interpolation, similar to what is done for the 
% velocity updating.
PP=UB(:,1:2);
H0=UB(:,3:4);
H1=UB(:,5:6);
H2=UB(:,7:8);
l_0=POLYNOMIALS(:,1);
l_1=POLYNOMIALS(:,2);
l_2=POLYNOMIALS(:,3);
% UB = [P,H0,H1,H2,U0_H0,link d]


    for j=1:length(PP)
%         j=1;
        PP=UB(j,1:2); %Boundary node P
        H1=UB(j,5:6); %Point H1 along link
        H2=UB(j,7:8); %Point H2 along link

        a=PP(1);
        b=PP(2);
        
        rho(b,a)=rho_R0*l_0(j) + ... 
            rho(H1(2),H1(1))*l_1(j) + rho(H2(2),H2(1))*l_2(j);
%       Impose analytical rho on outer boundary nodes
%         rho(b,a)=rho_ana(b,a);
    end
    