function u0_r = u0r_comp(r,frekvens,r0,x0,y0)
% u0r_comp computes u0 at the points where the line interconnecting
% P with its cardinal neighbors intersects the cylinder. The output u0_r is 
% used for the rate-of-strain computation.

u0=frekvens*r0;

% normal_r=zeros(length(r),8);
u0_r=zeros(length(r),8);


for i=1:length(r)
     for j=2:2:8
        
        if r(i,j) ~= 0

% %         Compute u0 there
        normal_x=(r(i,j-1)-x0)/r0; %x
        normal_y=(r(i,j)-y0)/r0; %y       

         
    
 u0_r(i,j-1)=-(normal_y/abs(normal_x)*u0)/(sqrt(1 + (normal_y/normal_x)^2));
 u0_r(i,j)  = (normal_x/abs(normal_y)*u0)/(sqrt(1 + (normal_x/normal_y)^2));
 
    if normal_x==0
        u0_r(i,j-1)=-normal_y*u0;
        
    elseif normal_y==0
        u0_r(i,j)=normal_x*u0;
        
    end
    
        else
      
    
        u0_r(i,j-1:j)=0;
        
        end
       
    end
   
        
end
