function [bound_solid,bound_bound,bound_fluid,n] = boundary_nodes_wet(NX,NY,obst,cylindertype)
% Function that gives position of the boundary-wet nodes and the indices pointing
% towards solid nodes and the indices pointing towards fluid nodes plus the
% indices pointing towards boundary nodes.
global q
global cx
global cy

bs=find(obst);
[bs_y,bs_x]=find(obst);
fluid=find(1-obst);
[fluid_y,fluid_x]=find(1-obst);
obst=double(obst);
fluid_xy=[fluid_x,fluid_y];
n=1;p=1;
dry_index=zeros(1,q);

% Finding the boundary nodes and their dry indices 
for i=1:length(fluid)
  for m=1:q
    for j=1:length(bs_y)     
            
             if fluid_x(i)+cx(m) - bs_x(j) == 0 ... %if neighbor is solid node
                && fluid_y(i)+cy(m) - bs_y(j)== 0
            
                      
                    bound_x(n)=fluid_x(i); %..then the node is a wet boundary node
                    bound_y(n)=fluid_y(i);%..then the node is a wet boundary node
                    
                    
                    
                    dry_index(1,m)=m;
                    bound_xy(n,:)=[bound_x(n),bound_y(n),dry_index];
                
                    if n>1
                        if   bound_xy(n-1,1) ~= bound_xy(n,1) || bound_xy(n-1,2) ~= bound_xy(n,2)
        
                        bound_solid(p,:)  = bound_xy(n-1,:);
                        
                                                           
                        
                        p=p+1;
                        end
                    end
                     n=n+1;  
                 
             else
                    continue
                                                                          
        end    
   end
  end
   
    dry_index=zeros(1,q);
end  

bound_solid(p,:) = bound_xy(n-1,:);

% STRCMP!
% Check to see if cylinder is too close to the walls.

% Erase entire 'check' for Taylor-Vortex w/periodic boundaries and only 'inner wall'
% if strcmp(cylindertype,'inner')
%         for p=1:length(bound_solid)
%             for m=1:q
%                 if bound_solid(p,1) +2*cx(m) <= 0 || bound_solid(p,2) + 2*cy(m) <= 0 ...
%                 || bound_solid(p,1) +2*cx(m) >= NX || bound_solid(p,2) + 2*cy(m) >= NY       
%                             disp('move cylinder away from walls')
%                             return
%                 end
%             end
%         end
        
%     elseif strcmp(cylindertype,'outer')
%         for p=1:length(bound_solid)
%             for m=1:q
%                 if bound_solid(p,1) +cx(m) < 1 || bound_solid(p,2) + cy(m) < 1 ...
%                 || bound_solid(p,1) +cx(m) > NX || bound_solid(p,2) + cy(m) > NY       
%                             disp('move cylinder away from walls')
%                             return
%                 end
%             end
%          end
% end
    


% Finding the boundary indices
boundary_index=zeros(1,q);
for i=1:length(bound_solid)
   for m=1:q
      for j=1:length(bound_solid)
             
             if bound_solid(i,1)+cx(m) - bound_solid(j,1) == 0 ...
             && bound_solid(i,2)+cy(m) - bound_solid(j,2) == 0
        
                boundary_index(1,m)=m;
                bound_bound(i,:)=[bound_solid(i,1),bound_solid(i,2),boundary_index];

             end
             
      end
    end
   boundary_index=zeros(1,q);
end

m=1:q;
for i=1:length(bound_solid)
    n(i)=0;
    fluid_index=m-bound_bound(i,3:2+q)-bound_solid(i,3:2+q);
    
    for j=1:length(fluid_index)
        
        if fluid_index(j) ~= 0
            n(i)=n(i)+1;
        end
        
        
    end
%     bound_fluid(i,:)=[bound_solid(i,1),bound_solid(i,2),m-bound_bound(i,3:2+q)-bound_solid(i,3:2+q)];
    bound_fluid(i,:)=[bound_solid(i,1),bound_solid(i,2),fluid_index];
    n(i)=max(n);
end

n=max(n);


                  
