function rho = density_walls(NX,NY,rho,f,g)
% Chopard and Dupois: The boundary is not part of the fluid domain
              
    for j=1:NY
        rho(1,j)=(f(1,j,4)+f(1,j,7)+f(1,j,8))/(g(1,j,4)+g(1,j,7)+g(1,j,8));%Southern wall
        rho(NY,j)=(f(NY,j,2)+f(NY,j,5)+f(NY,j,6))/(g(NY,j,2)+g(NY,j,5)+g(NY,j,6));%Northern wall
        rho(j,1)=(f(j,1,3)+f(j,1,6)+f(j,1,7))/(g(j,1,3)+g(j,1,6)+g(j,1,7)); %Western wall
        rho(j,NX)=(f(j,NX,1)+f(j,NX,5)+f(j,NX,8))/(g(j,NX,1)+g(j,NX,5)+g(j,NX,8));%Eastern wall
    end


% Hollis: The boundary is part of the fluid domain
% 
%     for j=1:NY
%         rho(1,j)         =(f(1,j,4)+f(1,j,7)+f(1,j,8)+f(1,j,1)+f(1,j,3)+f(1,j,9))/(g(1,j,4)+g(1,j,7)+g(1,j,8)+g(1,j,1)+g(1,j,3)+g(1,j,9));    %Southern wall
%         rho(NY,j)  =(f(NY,j,2)+f(NY,j,5)+f(NY,j,6)+f(NY,j,1)+f(NY,j,3)+f(NY,j,9))/(g(NY,j,2)+g(NY,j,5)+g(NY,j,6)+g(NY,j,1)+g(NY,j,3)+g(NY,j,9)); %Northern wall
%         rho(j,1)         =(f(j,1,3)+f(j,1,6)+f(j,1,7)+f(j,1,2)+f(j,1,4)+f(j,1,9))/(g(j,1,3)+g(j,1,6)+g(j,1,7)+g(j,1,2)+g(j,1,4)+g(j,1,9));    %Western wall
%         rho(j,NX)  =(f(j,NX,1)+f(j,NX,5)+f(j,NX,8)+f(j,NX,2)+f(j,NX,4)+f(j,NX,9))/(g(j,NX,1)+g(j,NX,5)+g(j,NX,8)+g(j,NX,2)+g(j,NX,4)+g(j,NX,9)); %Eastern wall
%     end