function [fluid,boundary,BOUNDARY,wetnodes,wet,fluid_opp,fluid_opp_bound_opp] = fluid_boundary_detect(OBST,obst,bound_fluid,bound_bound,BOUND_FLUID)
% fluid_boundary_detect gives the coordinates of the bulk fluid nodes,
% boundary nodes (near inner wall) and BOUNDARY NODES (near outer wall).
% wetnodes = boundary wet nodes or bulk fluid nodes.
% Last, this function finds fluid_opp from bound_fluid

global cx
global cy
global q

wetnodes=1-OBST-obst; %logical 1 if filled with fluid. Includes wet boundary nodes.
[wet_y,wet_x]=find(wetnodes);
wet=[wet_x,wet_y];
boundary=bound_fluid(:,1:2);
BOUNDARY=BOUND_FLUID(:,1:2);
b_and_B=[boundary;BOUNDARY];
% b_and_B=boundary; %TV specific!!

fluid = setxor(wet, b_and_B, 'rows');
% fluid = [F, F_E, F_N, F_W, F_S];
for i=1:length(fluid)

for j=1:4
c=[cx(j),cy(j)];
fluidcardinal(i,2*j-1:2*j) = fluid(i,:)+c;

end
end
fluid=[fluid,fluidcardinal];

if isempty(intersect(boundary,BOUNDARY,'rows'))
else return
end

fluid_opp=zeros(length(bound_fluid),q+2);
f_opp=[3,4,1,2,7,8,5,6,9];

for i=1:length(bound_fluid)
    fluid_opp(i,1:2)=bound_fluid(i,1:2);
    
    for j=1:q
        k=j+2;

    if bound_fluid(i,k)~=0
        fluid_opp(i,f_opp(j)+2)=f_opp(j);
    end
    end

end

fluid_opp_bound_opp=fluid_opp;

for i=1:length(bound_fluid)
    
    for j=1:q
        k=j+2;
        
        if bound_bound(i,k)~=0
            fluid_opp_bound_opp(i,f_opp(j)+2)=f_opp(j);
        end
    end
    
end






