
% [x,y]=meshgrid(1:NX,1:NY);
% ############ Taylor-Vortex #######################################################################

% STATIONARY
% function [ub,polynomials,fluid ...
%     u0_r,r ...
%     boundary,BOUNDARY,p,obst,OBST,bound_fluid,fluid_opp,fluid_opp_bound_opp,lms_app,lms,p0] = lattemain(NX,NY,x0,y0,R0,r0,x,y,ohm,ts,u_L)

% FOR THE TIME-DEPENDENT CASE, THE FOLLIWING HAVE TO BE COMPUTED FOR EVERY
% ITERATION:
% -u0_H0
% -p0
% -u0_r
% ub
% lattemain
function [H0,fluid ...
    r ...
    boundary,BOUNDARY,p,obst,OBST,bound_fluid,fluid_opp,fluid_opp_bound_opp,lms_app,lms] = lattemain(NX,NY,x0,y0,R0,r0,x,y)

            
[obst,cyl,cyl_x,cyl_y,CYL_x,CYL_y,OBST,CYL] = obst_cyl(x,y,x0,y0,r0,R0,NX); %Defining the obstacle: cylinder
% return
[bound_solid,bound_bound,bound_fluid,n] = boundary_nodes_wet(NX,NY,obst,'inner');

BOUND_FLUID=ones(0,2);
[fluid,boundary,BOUNDARY,wetnodes,wet,fluid_opp,fluid_opp_bound_opp] = ... 
    fluid_boundary_detect(OBST,obst,bound_fluid,bound_bound,BOUND_FLUID);

[normal] = inter(bound_fluid,x0,y0);

[bound_f_opp,H1,H2] = h_find(NX,NY,bound_fluid);


[linkmatrix,cylinder_x,cylinder_y] = c_intersect_driver(bound_fluid,bound_f_opp,cyl,H1,H2,'inner',n);


[p,r] = p_find(bound_fluid,cylinder_x,cylinder_y,obst);

[lms,lms_app,H0]=linkmachine(normal,linkmatrix,bound_fluid,H2,'inner',n);
% return

% The functions below have to be evaluated at
% every time step T.
% [u0_H0,p0]=u0_comp_tv(H0,ohm,ts,NX,NY,u_L);
% 
% u0_r = u0r_comp_tv(r,ohm,ts,NX,NY,u_L); 
% 
% [ub,polynomials] = ubound_comp(u0_H0,lms_app); 


return
figure(1)
plot(cyl_x,cyl_y,'b',CYL_x,CYL_y,'b--',x0,y0,'k*',bound_fluid(:,1),bound_fluid(:,2),'r*',BOUND_FLUID(:,1),BOUND_FLUID(:,2),'m*')
axis equal
axis([x0-R0 x0+R0 y0-R0 y0+R0])
% ylim([1 y0+1.5*r0])
legend('Inner wall','Outer wall','Center of cylinder','Inner boundary nodes','Outer boundary nodes','Location','SouthOutside')
grid minor







% ######## Taylor-Couette ################################################################################ 
% 
% function [ub,polynomials,UB,POLYNOMIALS,fluid ...
%     u0_r,U0_R,r,R ...
%     boundary,BOUNDARY,p,P,obst,OBST,bound_fluid,fluid_opp,fluid_opp_bound_opp,lms_app,LMS_APP,lms,LMS] = lattemain(NX,NY,x0,y0,R0,r0,FREKVENS,frekvens,x,y)
% 
% [obst,cyl,cyl_x,cyl_y,CYL_x,CYL_y,OBST,CYL] = obst_cyl(x,y,x0,y0,r0,R0,NX); %Defining the obstacle: cylinder
% 
% 
% [bound_solid,bound_bound,bound_fluid,n] = boundary_nodes_wet(NX,NY,obst,'inner');
% [BOUND_SOLID,BOUND_BOUND,BOUND_FLUID,N] = boundary_nodes_wet(NX,NY,OBST,'outer'); 
% 
% [fluid,boundary,BOUNDARY,wetnodes,wet,fluid_opp,fluid_opp_bound_opp] = ... 
%     fluid_boundary_detect(OBST,obst,bound_fluid,bound_bound,BOUND_FLUID);
% % break
% [normal] = inter(bound_fluid,x0,y0);
% [NORMAL] = inter(BOUND_FLUID,x0,y0);
% 
% [bound_f_opp,H1,H2] = h_find(NX,NY,bound_fluid);
% [BOUND_F_OPP,HH1,HH2] = h_find(NX,NY,BOUND_FLUID);
% 
% [linkmatrix,cylinder_x,cylinder_y] = c_intersect_driver(bound_fluid,bound_f_opp,cyl,H1,H2,'inner',n);
% [LINKMATRIX,CYLINDER_x,CYLINDER_y] = c_intersect_driver(BOUND_FLUID,BOUND_F_OPP,CYL,HH1,HH2,'outer',N); 
% 
% [p,r] = p_find(bound_fluid,cylinder_x,cylinder_y,obst);
% [P,R] = p_find(BOUND_FLUID,CYLINDER_x,CYLINDER_y,OBST); 
% % break
% [lms,lms_app,H0]=linkmachine(normal,linkmatrix,bound_fluid,H2,'inner',n);
% [LMS,LMS_APP,HH0]=linkmachine(NORMAL,LINKMATRIX,BOUND_FLUID,HH2,'outer',N);
% 
% % f_opp create!
% 
% [u0_H0,normal_H0] = u0_comp(H0,r0,x0,y0,frekvens); 
% [U0_H0,normal_HH0] = u0_comp(HH0,R0,x0,y0,FREKVENS); 
% 
% 
% u0_r = u0r_comp(r,frekvens,r0,x0,y0);
% U0_R = u0r_comp(R,FREKVENS,R0,x0,y0);
% 
% 
% 
% [ub,polynomials] = ubound_comp(u0_H0,lms_app);
% [UB,POLYNOMIALS] = ubound_comp(U0_H0,LMS_APP);


% [X,Y]=curveintersect(x1,y1,cyl(:,1),cyl(:,2))
% plot(x1,y1,'b',cyl(:,1),cyl(:,2),'k',X,Y,'ro')

% PLOTS
% contourf(obst,[0 1]); axis equal off; %Plot domain
% break
return
figure(2)
plot(cyl_x,cyl_y,'b',CYL_x,CYL_y,'b--',x0,y0,'k*',bound_fluid(:,1),bound_fluid(:,2),'r*',BOUND_FLUID(:,1),BOUND_FLUID(:,2),'m*')
axis equal
axis([x0-R0 x0+R0 y0-R0 y0+R0])
% ylim([1 y0+1.5*r0])
grid minor
% legend('cylinder walls','center of cylinder','wet boundary nodes')

% figure(3)
% y = find_inter(bound_fluid,slope,cyl,r0);
% grid



