clear
ohm=0; %Use for: POINT 2, first part
periods=2;
flow_period=50000
ohm=2*pi/flow_period; %frequency of the flow: POINT 2, second part
% ohm=0;
% Re=1;
% omega=10/6; %Relaxation frequency
% omega=1;
% NX=9;
% NY=9;

Re=1;%10
nu=1/Re; %dim.less
tau=3*nu+0.5;
omega=1/tau;

gridres=[8,16,32,64,128];
gridres_odd=[9,19,39,79,159];
% Use 11 nodes as lower limit!!
NX=gridres_odd(2);
NX=21;
NY=NX
% break
xvec=0:1/NX:1; %Computational domain. Must be positive definite!
yvec=xvec;

[x,y]=meshgrid(1:NX,1:NY);

% break
% Global variables
global t;global cx;global cy;global q;
[t,cx,cy,q]=d2q9();
aa=1-0.5*omega;
% break
% NX=length(xvec);
% NY=length(yvec);

Z=zeros(NY,NX,q); %Force term in collision. Eqn.(2.74) in Latt

sections=NY; %Ususally (NY-1)
h=1/sections; %Grid spacing
u_L=h; %Lattice speed

[Qxx,Qxy,Qyy] =Q_comp();

% Initialize
ux=zeros(NY,NX);uy=zeros(NY,NX);rho=ones(NY,NX);
dudx=zeros(NY,NX);dudy=zeros(NY,NX);dvdx=zeros(NY,NX);dvdy=zeros(NY,NX); 
f=f_comp(ux,uy,NY,NX,rho);

fout=f;

n=1;

x0=(NX+1)/2; y0=(NY+1)/2; r0=(NX-1)/4;
R0=2*r0;
% break
ts=1;
% Place 'lattemain' outside loop for stationary flow
% [ub,polynomials,fluid ...
%     u0_r,r ...
%     boundary,BOUNDARY,p,obst,OBST,bound_fluid,fluid_opp,fluid_opp_bound_opp,lms_app,lms,p0] = lattemain(NX,NY,x0,y0,R0,r0,x,y,ohm,ts,u_L);

% TIME-DEPENDENT FLOW!
[H0,fluid ...
    r ...
    boundary,BOUNDARY,p,obst,OBST,bound_fluid,fluid_opp,fluid_opp_bound_opp,lms_app,lms] = lattemain(NX,NY,x0,y0,R0,r0,x,y);


% LOOP STARTS HERE
for ts=0:periods*flow_period;

    if mod(ts,flow_period)==0
        disp(num2str(ts/flow_period))
    end
    
% ts=0;

% Force field and analytical velocity profile
[ux_ana,uy_ana,p_ana,rho_ana,Gx,Gy] = vel_force_comp2(NX,NY,xvec,yvec,ohm,Re,ts,u_L); %on grid nodes

% -------------------------------------------------------------------------

% -----------------------------------------------------------------------


wetnodes=1-obst-OBST;

[u0_H0,p0]=u0_comp_tv(H0,ohm,ts,NX,NY,u_L);

u0_r = u0r_comp_tv(r,ohm,ts,NX,NY,u_L); 

[ub,polynomials] = ubound_comp(u0_H0,lms_app); 
   
% break
% [LHSx,LHSy,RHSx,RHSy,xbalance,ybalance] = ns_test2(NX,NY,xvec,yvec,Re,ts,ohm);
% break
% Compute density from f
rho=density_comp(f);
% Compute velocity from f and rho
[ux,uy]=velocity_comp(f,rho);

[ux,uy]=force_correction(ux,uy,Gx,Gy); %(2.30) in Ltt. 

% feq   = f_comp(ux,uy,NY,NX,rho);
% break

% Update velocity on boundary nodes, u(P)
[ux,uy] = u_update(ux,uy,ux_ana,uy_ana,ub,polynomials,u_L);

Z=FT_comp(NX,NY,aa,ux,uy,Gx,Gy); %FT_comp is eqn.(2.74) in Ltt
% break

% Compute the rate of strain
% [dudx,dudy,dvdx,dvdy]             = rate_of_strain_fluid(NX,NY,ux,uy,fluid);
[dudx,dudy,dvdx,dvdy]             = ros_all(NX,NY,ux,uy,dudx,dudy,dvdx,dvdy);
[Sxx,Sxy,Syy,dudx,dudy,dvdx,dvdy] = rate_of_strain_bound(dudx,dudy,dvdx,dvdy,ux,uy,u0_r,r,boundary,p); %inner

[dudx_ana,dudy_ana,dvdx_ana,dvdy_ana] = ros_ana(NX,NY,xvec,yvec,ts,ohm,u_L); %\nabla u^{*}*u_L^2=\nabla u (num)
[Sxx,Sxy,Syy]                         = ros_from_gradients(dudx,dudy,dvdx,dvdy);
% Sxx=zeros(NY,NX);Sxy=zeros(NY,NX);Syy=zeros(NY,NX); %First order

QS = QS_comp(Qxx,Qxy,Qyy,Sxx,Sxy,Syy);

geq  = geq_comp(NY,NX,ux,uy);
gneq = gneq_comp(omega,QS);
g    = g_comp(geq,gneq); %g^{in}

% Compute density on boundary nodes locally

% rho = rho_update_local_fopp_bopp(rho,f,g,fluid_opp_bound_opp,rho_ana);
% rho = rho_update_local_fopp(rho,f,g,fluid_opp,rho_ana); %g^{in}, f^{ps}
rho = rho_update_nonlocal(polynomials,ub,rho,p0,rho_ana);
% rho=rho_ana; 

% break
% 
[feq,fneq]=f_rho_g(rho,geq,gneq);
f=f_reconstruct(feq,fneq,f,boundary,BOUNDARY); 

% Collision

OMEGA = collision_operator(f,feq,Z,omega);
fout  = collision_with_source(f,OMEGA);
f     = streaming(fout,f);
% break

% pressure = 1/3*(rho-1)/u_L^2; %Physical pressure

% Compute the error (2-norm of velocity when empty domain)
% [error_pressure,error_velocity,pressure] =
% results_manufactured(NX,NY,ux,uy,ux_ana,uy_ana,rho,p_ana,u_L); %L2-norm
[error_pressure,error_x_crossection,error_y_crossection,pressure] = results_manufactured_part3(NX,NY,x0,y0,r0,R0,ux,uy,ux_ana,uy_ana,rho,p_ana,u_L,wetnodes);%L1-norm

err_vel_vec_x(ts+1)=error_x_crossection;
err_vel_vec_y(ts+1)=error_y_crossection;
err_p_vec(ts+1)=error_pressure;
if mod(ts,flow_period)==0 && ts~=0   
       err_vel_T_x(n)=(1/flow_period)*sum(err_vel_vec_x(ts+1-flow_period:ts));
       err_vel_T_y(n)=(1/flow_period)*sum(err_vel_vec_x(ts+1-flow_period:ts));
       err_p_T(n)=(1/flow_period)*sum(err_p_vec(ts+1-flow_period:ts));
%        err_vel_T=(1/flow_period)*sum(err_vel_vec(ts+1-flow_period:ts));
    m(n)=n+1;
    n=n+1;    
end


% err_vel_vec(ts+1)=error_velocity;
% err_p_vec(ts+1)=error_pressure;
% if mod(ts,flow_period)==0 && ts~=0   
%        err_vel_T(n)=(1/flow_period)*sum(err_vel_vec(ts+1-flow_period:ts));
%        err_p_T(n)=(1/flow_period)*sum(err_p_vec(ts+1-flow_period:ts));
% %        err_vel_T=(1/flow_period)*sum(err_vel_vec(ts+1-flow_period:ts));
%     m(n)=n+1;
%     n=n+1;    
% end

% ts_vec(ts+1)=ts;
% error_velocity_vec(ts+1)=error_velocity;
% plot(ts_vec,error_velocity_vec,'k*')
% xlabel(['T with \omega = 1/',num2str(flow_period)])
% ylabel('Error')
% xlim([0 periods*flow_period])
% pause(.1)
% 2*pi*0.01
% mesh(ux/u_L)
% mesh(Gx)
% pause(.1)

end
format long
err_vel_T_x
% err_vel_T_y
% err_vel_T
err_p_T




% m
% err_vel_vec
% [err_vel_T,err_p_T]

% maxana=max(max(ux_ana))
% maxnum=max(max(ux/u_L))
% sections
% error_velocity
% error_pressure

% End of loop


