function [LHSx,LHSy,RHSx,RHSy,xbalance,ybalance] = ns_test(NX,NY,xvec,yvec,Gx,Gy,Re,ts,ohm)
% Test to see if analytical terms balance. All u = ux_ana ++


for i=1:NX
    for j=1:NY
    
X=xvec(i);
Y=yvec(j);


dudt=(1/4)*sin(ohm*ts)*ohm*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi;
dvdt=-(1/4)*sin(ohm*ts)*ohm*sin(pi*(X-1))*pi*(cos(pi*(Y-1))+1);
convx=-(1/16)*cos(ohm*ts)^2*(cos(pi*(X-1))+1)*sin(pi*(Y-1))^2*pi^3*sin(pi*(X-1))-(1/16)*cos(ohm*ts)^2*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1)*(cos(pi*(X-1))+1)*cos(pi*(Y-1));
convy=-(1/16)*cos(ohm*ts)^2*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3*cos(pi*(X-1))*(cos(pi*(Y-1))+1)-(1/16)*cos(ohm*ts)^2*sin(pi*(X-1))^2*pi^3*(cos(pi*(Y-1))+1)*sin(pi*(Y-1));
LHSx(j,i)=dudt+convx;
LHSy(j,i)=dvdt+convy;

dpdx=-cos(ohm*ts)*sin(pi*(X-1))*pi*cos(pi*(Y-1));
dpdy=-cos(ohm*ts)*cos(pi*(X-1))*sin(pi*(Y-1))*pi;
laplacianx =  (1/4)*cos(ohm*ts)*cos(pi*(X-1))*pi^3*sin(pi*(Y-1))+(1/4)*cos(ohm*ts)*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3;
laplaciany = -(1/4)*cos(ohm*ts)*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1)-(1/4)*cos(ohm*ts)*sin(pi*(X-1))*pi^3*cos(pi*(Y-1));
Gx= (1/4)*sin(ohm*ts)*ohm*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi-(1/16)*cos(ohm*ts)^2*(cos(pi*(X-1))+1)*sin(pi*(Y-1))^2*pi^3*sin(pi*(X-1))-(1/16)*cos(ohm*ts)^2*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1)*(cos(pi*(X-1))+1)*cos(pi*(Y-1))-cos(ohm*ts)*sin(pi*(X-1))*pi*cos(pi*(Y-1))-((1/4)*cos(ohm*ts)*cos(pi*(X-1))*pi^3*sin(pi*(Y-1))+(1/4)*cos(ohm*ts)*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3)/Re;
Gy=-(1/4)*sin(ohm*ts)*ohm*sin(pi*(X-1))*pi*(cos(pi*(Y-1))+1)-(1/16)*cos(ohm*ts)^2*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3*cos(pi*(X-1))*(cos(pi*(Y-1))+1)-(1/16)*cos(ohm*ts)^2*sin(pi*(X-1))^2*pi^3*(cos(pi*(Y-1))+1)*sin(pi*(Y-1))-cos(ohm*ts)*cos(pi*(X-1))*sin(pi*(Y-1))*pi-(-(1/4)*cos(ohm*ts)*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1)-(1/4)*cos(ohm*ts)*sin(pi*(X-1))*pi^3*cos(pi*(Y-1)))/Re;
RHSx(j,i)  =  -dpdx + 1/Re*laplacianx + Gx;
RHSy(j,i)  =  -dpdy + 1/Re*laplaciany + Gy;

    end
end
xbalance=LHSx-RHSx;
ybalance=LHSy-RHSy;