function [LHSx,LHSy,RHSx,RHSy,xbalance,ybalance] = ns_test2(NX,NY,xvec,yvec,Re,ts,ohm)
% Test to see if analytical terms balance. All u = ux_ana ++


for i=1:NX
    for j=1:NY
    
X=xvec(i);
Y=yvec(j);


dudt= (1/2)*sin(ohm*ts)*ohm*cos(2*pi*X)*sin(2*pi*Y)/pi;
dvdt=-(1/2)*sin(ohm*ts)*ohm*sin(2*pi*X)*cos(2*pi*Y)/pi;
convx=-(1/2)*cos(ohm*ts)^2*cos(2*pi*X)*sin(2*pi*Y)^2*sin(2*pi*X)/pi-(1/2)*cos(ohm*ts)^2*sin(2*pi*X)*cos(2*pi*Y)^2*cos(2*pi*X)/pi;
convy=-(1/2)*cos(ohm*ts)^2*cos(2*pi*X)^2*sin(2*pi*Y)*cos(2*pi*Y)/pi-(1/2)*cos(ohm*ts)^2*sin(2*pi*X)^2*cos(2*pi*Y)*sin(2*pi*Y)/pi;
LHSx(j,i)=dudt+convx;
LHSy(j,i)=dvdt+convy;

dpdx=(1/4)*sin(4*pi*X)*cos(ohm*ts)^2/pi;
dpdy=(1/4)*sin(4*pi*Y)*cos(ohm*ts)^2/pi;
laplacianx =  4*cos(ohm*ts)*cos(2*pi*X)*pi*sin(2*pi*Y) ;
laplaciany = -4*cos(ohm*ts)*sin(2*pi*X)*pi*cos(2*pi*Y);
Gx= (1/2)*sin(ohm*ts)*ohm*cos(2*pi*X)*sin(2*pi*Y)/pi-(1/2)*cos(ohm*ts)^2*cos(2*pi*X)*sin(2*pi*Y)^2*sin(2*pi*X)/pi-(1/2)*cos(ohm*ts)^2*sin(2*pi*X)*cos(2*pi*Y)^2*cos(2*pi*X)/pi+(1/4)*sin(4*pi*X)*cos(ohm*ts)^2/pi-4*cos(ohm*ts)*cos(2*pi*X)*pi*sin(2*pi*Y)/Re;
Gy= -(1/2)*sin(ohm*ts)*ohm*sin(2*pi*X)*cos(2*pi*Y)/pi-(1/2)*cos(ohm*ts)^2*cos(2*pi*X)^2*sin(2*pi*Y)*cos(2*pi*Y)/pi-(1/2)*cos(ohm*ts)^2*sin(2*pi*X)^2*cos(2*pi*Y)*sin(2*pi*Y)/pi+(1/4)*sin(4*pi*Y)*cos(ohm*ts)^2/pi+4*cos(ohm*ts)*sin(2*pi*X)*pi*cos(2*pi*Y)/Re;
RHSx(j,i)  =  -dpdx + 1/Re*laplacianx + Gx;
RHSy(j,i)  =  -dpdy + 1/Re*laplaciany + Gy;

    end
end
xbalance=LHSx-RHSx;
ybalance=LHSy-RHSy;