function [dudx,dudy,dvdx,dvdy] = rate_of_strain_fluid(NX,NY,ux,uy,fluid)
% RATE_OF_STRAIN_COUETTE computes S-tensor for the bulk fluid nodes
% by means of central differences. All elements in S is computed because 
% S has no non-zero elements in general.

global cx
global cy

dudx=zeros(NY,NX);
dudy=zeros(NY,NX);
dvdx=zeros(NY,NX);
dvdy=zeros(NY,NX);

for i=1:length(fluid)

        
     F=fluid(i,1:2); %Bulk fluid node F
     F_E=fluid(i,3:4); %Eastern neighbor
     F_N=fluid(i,5:6); %Northern neighbor
     F_W=fluid(i,7:8); %Western neighbor
     F_S=fluid(i,9:10); %Southern neighbor
     a=F(1);
     b=F(2);
       
     dudx(b,a)=0.5*ux(F_E(2),F_E(1))-0.5*ux(F_W(2),F_W(1));
     dudy(b,a)=0.5*ux(F_N(2),F_N(1))-0.5*ux(F_S(2),F_S(1));
     dvdx(b,a)=0.5*uy(F_E(2),F_E(1))-0.5*uy(F_W(2),F_W(1));
     dvdy(b,a)=0.5*uy(F_N(2),F_N(1))-0.5*uy(F_S(2),F_S(1));
end

Sxx=dudx;
Sxy=0.5*(dudy+dvdx);
Syy=dvdy;





    
