function [error_pressure,error_velocity,pressure] = results_manufactured(NX,NY,ux,uy,ux_ana,uy_ana,rho,p_ana,u_L)
% L2-norm of error


error_velocity=0;
for i=1:NY 
    for j=1:NX
    error_velocity= error_velocity + ...
    ((ux(i,j)/u_L - ux_ana(i,j))*(ux(i,j)/u_L - ux_ana(i,j))) + ...
    ((uy(i,j)/u_L - uy_ana(i,j))*(uy(i,j)/u_L - uy_ana(i,j)));
    end
end
error_velocity=sqrt(error_velocity/NY/NX);

pressure = 1/3*(rho-1); %Numerical pressure

error_pressure=0;
for i=1:NY 
    for j=1:NX
    error_pressure= error_pressure + ...
    ((pressure(i,j)/u_L^2 - p_ana(i,j))*(pressure(i,j)/u_L^2 - p_ana(i,j))); 
    end
end
error_pressure=sqrt(error_pressure/NY/NX);

