function [error_pressure,error_x_crossection,error_y_crossection,pressure] = results_manufactured_part3(NX,NY,x0,y0,r0,R0,ux,uy,ux_ana,uy_ana,rho,p_ana,u_L,wetnodes)
% L1-norm of error along a section for velocity
a=ceil(x0+r0+1):floor(x0+R0);
b=ceil(y0+r0+1):floor(y0+R0);

error_y_crossection=(1/length(b))*sum(sqrt((ux(b,x0)/u_L-ux_ana(b,x0)).^2+(uy(b,x0)/u_L-uy_ana(b,x0)).^2));
error_x_crossection=(1/length(a))*sum(sqrt((ux(y0,a)/u_L-ux_ana(y0,a)).^2+(uy(y0,a)/u_L-uy_ana(y0,a)).^2));

[wet_y,wet_x]=find(wetnodes);
wet=[wet_x,wet_y];

% error_x_crossection=0; %NOT crossection but L2-norm
% for i=1:length(wet)
%     x=wet_x(i);
%     y=wet_y(i);
%     
%     error_x_crossection= error_x_crossection + ...
%     ((ux(y,x)/u_L - ux_ana(y,x))*(ux(y,x)/u_L - ux_ana(y,x))) + ...
%     ((uy(y,x)/u_L - uy_ana(y,x))*(uy(y,x)/u_L - uy_ana(y,x))); 
% end
% error_x_crossection=sqrt(error_x_crossection/length(wet));
% 
% error_y_crossection=error_x_crossection;


pressure = 1/3*(rho-1); %Numerical pressure
% 
% error_pressure=(1/length(a))*sum(sqrt((pressure(y0,a)/u_L^2-p_ana(y0,a)).^2));
% 
% L2-norm of error in pressure on the wet nodes
error_pressure=0;
for i=1:length(wet)
    x=wet_x(i);
    y=wet_y(i);
    
    error_pressure= error_pressure + ...
    ((pressure(y,x)/u_L^2 - p_ana(y,x))*(pressure(y,x)/u_L^2 - p_ana(y,x))); 
end
error_pressure=sqrt(error_pressure/length(wet));


