function rho = rho_update_local_fopp_bopp(rho,f,g,fluid_opp_bound_opp,rho_ana)
% rho_update_local_fopp_bopp updates the density at the inner boundary nodes
% by dividing the post-streamed f-populations by the g-in-populations.
% The summing is over the f_opp plus the b_opp-incices. Might lead to numerical
% instabilities. 

% This procedure is  done for the inner boundary nodes only.
% Prosedure slightly different from 'rho_update_local_fopp'.

global q
% FIX!
for i=1:length(fluid_opp_bound_opp)
% i=1;
    a=fluid_opp_bound_opp(i,1);
    b=fluid_opp_bound_opp(i,2);

    for j=3:q+2
        k=j-2;

if fluid_opp_bound_opp(i,j)~=0  
   d(k)=f(b,a,k);
   e(k)=g(b,a,k);

end
    end
  rho(b,a)=sum(d)/sum(e);
  % Impose analytical pressure on inner boundary nodes
  rho(b,a)=rho_ana(b,a);
end

% [dry_y,dry_x]=find(1-wetnodes);
% dry=[dry_x,dry_y];
% 
% for i=1:length(dry)
%     a=dry(i,1);
%     b=dry(i,2);
%     
%     rho(b,a)=rho_R0;
% end

% rho=rho_ana;
