function [dudx,dudy,dvdx,dvdy] = ros_all(NX,NY,ux,uy,dudx,dudy,dvdx,dvdy)
% 'ros_all' computes the rate of strain by means of central (second order) finite
% differences.

dudx(:,2:NX-1)=0.5*ux(:,3:NX)-0.5*ux(:,1:NX-2);
dudy(2:NY-1,:)=0.5*ux(3:NY,:)-0.5*ux(1:NY-2,:);
dvdx(:,2:NX-1)=0.5*uy(:,3:NX)-0.5*uy(:,1:NX-2);
dvdy(2:NY-1,:)=0.5*uy(3:NY,:)-0.5*uy(1:NY-2,:);

% Taking advantage of periodic boundaries!
dudx(:,NX)=0.5*ux(:,1)-0.5*ux(:,NX-1);
dudx(:,1) =0.5*ux(:,2)-0.5*ux(:,NX);
dudy(NY,:)=0.5*ux(1,:)-0.5*ux(NY-1,:);
dudy(1,:) =0.5*ux(2,:)-0.5*ux(NY,:);

dvdx(:,NX)=0.5*uy(:,1)-0.5*uy(:,NX-1);
dvdx(:,1) =0.5*uy(:,2)-0.5*uy(:,NX);
dvdy(NY,:)=0.5*uy(1,:)-0.5*uy(NY-1,:);
dvdy(1,:) =0.5*uy(2,:)-0.5*uy(NY,:);
