function [dudx_ana,dudy_ana,dvdx_ana,dvdy_ana] = ros_ana(NX,NY,xvec,yvec,ts,ohm,u_L)
% These are the components of the analytical rate-of-strain tensor

for i=1:NX
    for j=1:NY
        
        
X=xvec(i);
Y=yvec(j);

dudx_ana(j,i)= cos(ohm*ts)*sin(2*pi*X)*sin(2*pi*Y);
dudy_ana(j,i)= -cos(ohm*ts)*cos(2*pi*X)*cos(2*pi*Y);
dvdx_ana(j,i)= cos(ohm*ts)*cos(2*pi*X)*cos(2*pi*Y);
dvdy_ana(j,i)= -cos(ohm*ts)*sin(2*pi*X)*sin(2*pi*Y);

    end
end

dudx_ana=dudx_ana*u_L^2;
dudy_ana=dudy_ana*u_L^2;
dvdx_ana=dvdx_ana*u_L^2;
dvdy_ana=dvdy_ana*u_L^2;