function [u0_H0,p0]=u0_comp_tv(H0,ohm,ts,NX,NY,u_L)
% This function must be evaluated for each time step (T) in the
% time-dependent Taylor-Vortx Flow (omega \neq 0), where omega is the
% period of the flow.

H0_x=H0(:,1);
H0_y=H0(:,2);

for i=1:length(H0)
    
    x=(H0_x(i)-1)/(NX-1);
    y=(H0_y(i)-1)/(NY-1);
    
    u0_x(i)=-(1/2)*cos(ohm*ts)*cos(2*pi*x)*sin(2*pi*y)/pi;
    u0_y(i)= (1/2)*cos(ohm*ts)*sin(2*pi*x)*cos(2*pi*y)/pi;
    
    p0(i)  = -(1/16)*(cos(4*pi*x)+cos(4*pi*y))*cos(ohm*ts)^2/pi^2;
    
end

u0_x=u0_x*u_L;
u0_y=u0_y*u_L;
p0=p0*u_L^2;
u0_H0=[u0_x',u0_y'];
p0=p0';