function u0_r = u0r_comp_tv(r,ohm,ts,NX,NY,u_L)
% u0r_comp computes u0 at the points where the line interconnecting
% P with its cardinal neighbors intersects the cylinder. The output u0_r is 
% used for the rate-of-strain computation.

u0_r=zeros(length(r),8);

for i=1:length(r)
     for j=2:2:8
        
         rx=r(i,j-1);
         ry=r(i,j);
         
         x=(rx-1)/(NX-1);
         y=(ry-1)/(NY-1);
         
         
        if r(i,j) ~= 0
         
    
 u0_r(i,j-1)= -(1/2)*cos(ohm*ts)*cos(2*pi*x)*sin(2*pi*y)/pi; %rhs is u0x
 u0_r(i,j)  =  (1/2)*cos(ohm*ts)*sin(2*pi*x)*cos(2*pi*y)/pi; %rhs is u0y
        
 
        else
      
    
        u0_r(i,j-1:j)=0;
        
        end
       
    end
   
        
end

u0_r=u0_r*u_L; %Now in numerical units

% BE CAREFUL WITH THE UNITS YOU PUT INTO THE RATE OF STRAIN
% COMPUTATION!!!!!!