function [ux,uy] = u_update(ux,uy,ux_ana,uy_ana,ub,polynomials,u_L)
% u_update updates the macroscopic velocity on the boundary nodes by means 
% of Lagrange interpolation. 

PP=ub(:,1:2);
H0=ub(:,3:4);
H1=ub(:,5:6);
H2=ub(:,7:8);
u0=ub(:,9:10);
u0_x=u0(:,1);
u0_y=u0(:,2);
l_0=polynomials(:,1);
l_1=polynomials(:,2);
l_2=polynomials(:,3);
% ub = [P,H0,H1,H2,U0_H0,link d]


    for j=1:length(PP)
%         j=1;
        PP=ub(j,1:2); %Boundary node P
        H1=ub(j,5:6); %Point H1 along link
        H2=ub(j,7:8); %Point H2 along link

        a=PP(1);
        b=PP(2);
        
        ux(b,a)=u0_x(j)*l_0(j) + ... %...then find uP by interpolation
            ux(H1(2),H1(1))*l_1(j) + ux(H2(2),H2(1))*l_2(j);
        uy(b,a)=u0_y(j)*l_0(j) + ... %...then find uP by interpolation
            uy(H1(2),H1(1))*l_1(j) + uy(H2(2),H2(1))*l_2(j);
        
%         Impose analytical solution on boundary nodes
%         ux(b,a)=ux_ana(b,a)*u_L; %(?)
%         uy(b,a)=uy_ana(b,a)*u_L; %(?)
        
    end
    

        
    

