function [ub,polynomials] = ubound_comp(u0,lms_app)
% Computes the polynomials to be used in the interpolation used to approximate
% the value on the boundary nodes of a certain quantity (density or
% velocity) when a boundary condition has been imposed on that quantity 
% on the wall there.
% ub = [P,H0,H1,H2,U0,link b]
ub = [lms_app(:,1:2),lms_app(:,7:8),lms_app(:,5:6),lms_app(:,3:4),u0,lms_app(:,9)];

dp=sqrt((ub(:,1)-ub(:,3)).^2 + (ub(:,2)-ub(:,4)).^2);
dH1=sqrt((ub(:,5)-ub(:,3)).^2 + (ub(:,6)-ub(:,4)).^2);
dH2=sqrt((ub(:,7)-ub(:,3)).^2 + (ub(:,8)-ub(:,4)).^2);

% l_i(dp), i=0,1,2
l_0=(dp-dH1).*(dp-dH2)./dH1./dH2;
l_1=dp.*(dp-dH2)./dH1./(dH1-dH2);
l_2=dp.*(dp-dH1)./dH2./(dH2-dH1);

polynomials=[l_0,l_1,l_2];

    
    
    
    
    

