function [ux_ana,uy_ana,p_ana,rho_ana,Gx,Gy] = vel_force_comp(NX,NY,xvec,yvec,ohm,Re,ts,u_L)
                                               
ux_ana=zeros(NY,NX);
uy_ana=zeros(NY,NX);
p_ana=zeros(NY,NX);
Gx=zeros(NY,NX);
Gy=zeros(NY,NX);


for i=1:NX
    for j=1:NY
    
X=xvec(i);
Y=yvec(j);

ux_ana(j,i)=-0.25*cos(ohm*ts)*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi;
uy_ana(j,i)= 0.25*cos(ohm*ts)*sin(pi*(X-1))*pi*(cos(pi*(Y-1))+1);

p_ana(j,i)=cos(ohm*ts)*cos(pi*(X-1))*cos(pi*(Y-1));
% 
% Gx(j,i) = 0.25*sin(ohm*ts)*ohm*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi ... %duxdt
%     -0.0625*(cos(ohm*ts))^2*(cos(pi*(X-1))+1)*(sin(pi*(Y-1)))^2*pi^3*sin(pi*(X-1)) ...
%     -0.0625*(cos(ohm*ts))^2*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1)*(cos(pi*(X-1))+1) ...
%     *cos(pi*(Y-1)) ...
% -cos(ohm*ts)*sin(pi*(X-1))*pi*cos(pi*(Y-1)) ... %dpdx
% -1/Re*(0.25*cos(ohm*ts)*cos(pi*(X-1))*pi^3*sin(pi*(Y-1)) ... %\Delta ux
%      + 0.25*cos(ohm*ts)*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3);
 
 Gx(j,i)=(1/4)*sin(ohm*ts)*ohm*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi-(1/16)*cos(ohm*ts)^2*(cos(pi*(X-1))+1)*sin(pi*(Y-1))^2*pi^3*sin(pi*(X-1))-(1/16)*cos(ohm*ts)^2*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1)*(cos(pi*(X-1))+1)*cos(pi*(Y-1))-cos(ohm*ts)*sin(pi*(X-1))*pi*cos(pi*(Y-1))-((1/4)*cos(ohm*ts)*cos(pi*(X-1))*pi^3*sin(pi*(Y-1))+(1/4)*cos(ohm*ts)*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3)/Re;
 
 
% Gy(j,i) = -0.25*sin(ohm*ts)*ohm*sin(pi*(X-1))*pi*(cos(pi*(Y-1))+1) ... %duydt
%     -0.0625*(cos(ohm*ts))^2*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3*cos(pi*(X-1))*(cos(pi*(Y-1)+1)) ...
%     -0.0625*(cos(ohm*ts))^2*(sin(pi*(X-1)))^2*pi^3*(cos(pi*(Y-1))+1)*sin(pi*(Y-1)) ...
%     -cos(ohm*ts)*cos(pi*(X-1))*sin(pi*(Y-1))*pi ... %dpdy
% -1/Re*(-0.25*cos(ohm*ts)*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1) ... %\Delta uy
%       - 0.25*cos(ohm*ts)*sin(pi*(X-1))*pi^3*cos(pi*(Y-1)));   
%    
  
  Gy(j,i)=-(1/4)*sin(ohm*ts)*ohm*sin(pi*(X-1))*pi*(cos(pi*(Y-1))+1)-(1/16)*cos(ohm*ts)^2*(cos(pi*(X-1))+1)*sin(pi*(Y-1))*pi^3*cos(pi*(X-1))*(cos(pi*(Y-1))+1)-(1/16)*cos(ohm*ts)^2*sin(pi*(X-1))^2*pi^3*(cos(pi*(Y-1))+1)*sin(pi*(Y-1))-cos(ohm*ts)*cos(pi*(X-1))*sin(pi*(Y-1))*pi-(-(1/4)*cos(ohm*ts)*sin(pi*(X-1))*pi^3*(cos(pi*(Y-1))+1)-(1/4)*cos(ohm*ts)*sin(pi*(X-1))*pi^3*cos(pi*(Y-1)))/Re;

    end
end

Gx=Gx*u_L^3; %Asymptotic analysis of lbe (32)
Gy=Gy*u_L^3;

rho_ana=3*p_ana*u_L^2 + 1;
