function [ux_ana,uy_ana,p_ana,rho_ana,Gx,Gy] = vel_force_comp2(NX,NY,xvec,yvec,ohm,Re,ts,u_L)

ux_ana=zeros(NY,NX);
uy_ana=zeros(NY,NX);
p_ana=zeros(NY,NX);
Gx=zeros(NY,NX);
Gy=zeros(NY,NX);


for i=1:NX
    for j=1:NY
    
X=xvec(i);
Y=yvec(j);

ux_ana(j,i)=-(1/2)*cos(ohm*ts)*cos(2*pi*X)*sin(2*pi*Y)/pi;
uy_ana(j,i)=(1/2)*cos(ohm*ts)*sin(2*pi*X)*cos(2*pi*Y)/pi;

p_ana(j,i)=-(1/16)*(cos(4*pi*X)+cos(4*pi*Y))*cos(ohm*ts)^2/pi^2;

Gx(j,i)=(1/2)*sin(ohm*ts)*ohm*cos(2*pi*X)*sin(2*pi*Y)/pi - 4*cos(ohm*ts)*cos(2*pi*X)*pi*sin(2*pi*Y)/Re;

Gy(j,i)=-(1/2)*sin(ohm*ts)*ohm*sin(2*pi*X)*cos(2*pi*Y)/pi + 4*cos(ohm*ts)*sin(2*pi*X)*pi*cos(2*pi*Y)/Re;

    end
end

Gx=Gx*u_L^3; %Asymptotic analysis of lbe (32)
Gy=Gy*u_L^3;

rho_ana=3*p_ana*u_L^2 + 1; %NB! not physical (numerical)!
